diff --git a/test/integration/local_web_setup_e2e_test.rb b/test/integration/local_web_setup_e2e_test.rb
new file mode 100644
index 00000000..2cf89575
--- /dev/null
+++ b/test/integration/local_web_setup_e2e_test.rb
@@ -0,0 +1,466 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "json"
+require "cgi"
+require "net/http"
+require "stringio"
+require "uri"
+require "hive/commands/setup"
+require "hive/setup/diagnostics"
+require "hive/commands/web/service_installer"
+require "hive/commands/daemon/service_installer"
+require "hive/daemon/status_report"
+require "hive/web/app_bundle"
+require "hive/web/dispatcher"
+require "hive/daemon/dispatch_request_queue"
+require "hive/commands/service_installer/outcome"
+require "hive/tui/bubble_model"
+require "hive/tui/state_source"
+
+# Hermetic local-setup acceptance: fake package/service managers, real temp
+# git-shaped project paths, shared XDG state. Proves setup composition,
+# common binary selection, independent web/daemon units, and repair enqueue.
+class LocalWebSetupE2ETest < Minitest::Test
+  include HiveTestHelper
+
+  REPO_ROOT = File.expand_path("../..", __dir__)
+  FAKE_AGENT_BIN = File.join(REPO_ROOT, "web", "test", "e2e", "support")
+  LIVE_E2E_ENV = "HIVE_LIVE_LOCAL_WEB_E2E"
+
+  # A service-manager-shaped adapter that starts the production commands as
+  # real foreground process groups. It keeps the acceptance hermetic while
+  # proving the same current binary can boot independent daemon and Rails
+  # services without writing to the host's systemd/launchd state.
+  class LiveProcessInstaller
+    attr_reader :messages, :target_path, :pid
+
+    def initialize(name:, binary_path:, args:, log_path:)
+      @name = name
+      @binary_path = binary_path
+      @args = args
+      @log_path = log_path
+      @target_path = "#{log_path}.service"
+      @messages = []
+      @pid = nil
+    end
+
+    def install!(autostart:, force: false)
+      File.write(target_path, "ExecStart=#{@binary_path} #{@args.join(' ')}\n")
+      start_process! if autostart
+      Hive::Commands::ServiceInstaller::Outcome.new(:written)
+    end
+
+    def status_snapshot
+      {
+        "platform" => "linux",
+        "unit_path" => target_path,
+        "service_installed" => File.file?(target_path),
+        "service_enabled" => !@pid.nil?,
+        "service_active" => process_alive?
+      }
+    end
+
+    def restart!
+      stop!
+      start_process!
+      :ok
+    rescue SystemCallError => e
+      @messages << "#{@name} restart failed: #{e.message}"
+      :failed
+    end
+
+    def stop!
+      return unless @pid
+
+      Process.kill("TERM", -@pid)
+      Process.wait(@pid)
+    rescue Errno::ESRCH, Errno::ECHILD
+      nil
+    ensure
+      @pid = nil
+    end
+
+    private
+
+    def start_process!
+      FileUtils.mkdir_p(File.dirname(@log_path))
+      log = File.open(@log_path, "w")
+      @pid = Process.spawn(@binary_path, *@args, pgroup: true, out: log, err: log)
+      log.close
+    end
+
+    def process_alive?
+      return false unless @pid
+
+      Process.kill(0, @pid)
+      true
+    rescue Errno::ESRCH
+      false
+    end
+  end
+
+  # Setup calls `ensure_installed!` without a source because production uses a
+  # release download. The acceptance uses the checked-out release tree but the
+  # real AppBundle staging, Bundler install, version stamp, and atomic swap.
+  class LocalReleaseBundle < Hive::Web::AppBundle
+    def initialize(source:, **kwargs)
+      @local_source = source
+      super(**kwargs)
+    end
+
+    def ensure_installed!(source: nil)
+      super(source: source || @local_source)
+    end
+  end
+
+  def healthy_results
+    %w[ruby git tmux gh claude codex node npm qmd web_bundle sqlite].map do |name|
+      Hive::Setup::Diagnostics::Result.new(
+        name: name, status: "ok", detail: "#{name} ok",
+        fix: nil, bootstrappable: false
+      )
+    end
+  end
+
+  def test_setup_service_installs_both_units_with_one_binary
+    with_xdg_home do |home|
+      project = File.join(home, "proj")
+      FileUtils.mkdir_p(project)
+      # Pretend already initialized so enroll path is taken.
+      FileUtils.mkdir_p(File.join(project, ".hive-state"))
+
+      hive_bin = File.join(home, "bin", "hive")
+      FileUtils.mkdir_p(File.dirname(hive_bin))
+      File.write(hive_bin, "#!/bin/sh\n")
+      FileUtils.chmod(0o755, hive_bin)
+
+      daemon_cmds = []
+      web_cmds = []
+      daemon = Hive::Commands::Daemon::ServiceInstaller.new(
+        host_os: "linux",
+        home: home,
+        binary_path: hive_bin,
+        systemctl_available: true,
+        runner: ->(argv) { daemon_cmds << argv; true }
+      )
+      web = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "linux",
+        home: home,
+        binary_path: hive_bin,
+        systemctl_available: true,
+        runner: ->(argv) { web_cmds << argv; true }
+      )
+
+      report = Hive::Setup::Diagnostics::Report.new(
+        results: healthy_results, platform: "linux", ok: true
+      )
+      probe = Object.new
+      probe.define_singleton_method(:call) { report }
+
+      out = StringIO.new
+      cmd = Hive::Commands::Setup.new(
+        project_path: project,
+        service: true,
+        json: true,
+        binary_path: hive_bin,
+        diagnostics: probe,
+        daemon_installer: daemon,
+        web_installer: web,
+        init_runner: ->(*) { flunk "should enroll, not init" },
+        enroll_runner: ->(path) {
+          Hive::Config.register_project(name: "proj", path: path)
+          "enrolled"
+        },
+        qmd_installer: -> { "qmd ok" },
+        app_bundle: Hive::Web::AppBundle.new(
+          data_home: File.join(home, "data", "hive"),
+          env: {},
+          source_app_dir: File.join(home, "nope"),
+          downloader: ->(*) { },
+          bundler: ->(*) { }
+        ).tap { |b|
+          FileUtils.mkdir_p(File.join(b.managed_app_dir, "config"))
+          File.write(File.join(b.managed_app_dir, "config", "application.rb"), "#\n")
+          File.write(b.version_stamp_path, "#{Hive::VERSION}\n")
+        },
+        output: out,
+        err: StringIO.new
+      )
+
+      assert cmd.call
+      payload = JSON.parse(out.string)
+      assert payload["ok"], payload.inspect
+      assert_equal hive_bin, payload["binary_path"]
+      assert_equal "http://127.0.0.1:4567", payload["web_url"]
+
+      daemon_unit = File.read(daemon.target_path)
+      web_unit = File.read(web.target_path)
+      assert_includes daemon_unit, "ExecStart=#{hive_bin} daemon start"
+      assert_includes web_unit, "ExecStart=#{hive_bin} web"
+      refute_equal daemon.target_path, web.target_path
+
+      # Drift: rewrite daemon unit to wrong binary, status reports path drift.
+      wrong = File.join(home, "wrong-hive")
+      File.write(wrong, "#!/bin/sh\n")
+      FileUtils.chmod(0o755, wrong)
+      File.write(
+        daemon.target_path,
+        daemon_unit.gsub("ExecStart=#{hive_bin} daemon start", "ExecStart=#{wrong} daemon start")
+      )
+      assert_equal wrong, daemon.installed_binary_path
+      assert_equal hive_bin, daemon.resolved_binary_for_status
+      status = Hive::Daemon::StatusReport.new(
+        hive_home: Hive::Paths.state_home,
+        binary_path: hive_bin,
+        installer: daemon,
+        version_probe: ->(*) { Hive::VERSION }
+      ).to_h
+      assert_equal "path", status["binary_drift"], status.inspect
+
+      # Repair enqueue uses exact allowlist.
+      request_id = Hive::Web::Dispatcher.new.queue_daemon_repair!
+      files = Dir[File.join(Hive::Paths.state_home, "dispatch_requests", "*.json")]
+      body = files.map { |f| File.read(f) }.find { |t| t.include?(request_id) }
+      parsed = JSON.parse(body)
+      assert_equal %w[hive daemon install --force], parsed["argv"]
+      assert_equal "__hive_host__", parsed["project"]
+    end
+  end
+
+  def test_foreground_and_managed_share_same_state_home
+    with_xdg_home do |_home|
+      state = Hive::Paths.state_home
+      assert_equal File.join(state, "web-storage"),
+                   File.join(Hive::Paths.state_home, "web-storage")
+      # Config defaults bind loopback for local mode.
+      cfg = Hive::Config.load_global_web
+      assert_equal "127.0.0.1", cfg["bind"]
+      assert_equal true, cfg["local_loopback"]
+    end
+  end
+
+  def test_live_fresh_setup_and_bidirectional_tui_web_dispatch
+    skip "set #{LIVE_E2E_ENV}=1 to run the live Rails/daemon acceptance" unless ENV[LIVE_E2E_ENV] == "1"
+
+    with_xdg_home do |sandbox|
+      with_tmp_git_repo do |project_root|
+        prepare_fast_daemon_config!
+        prepare_local_release_gem!
+        hive_bin = write_current_binary_wrapper!(sandbox)
+        app_bundle = LocalReleaseBundle.new(
+          source: File.join(REPO_ROOT, "web"),
+          data_home: Hive::Paths.data_home,
+          source_app_dir: File.join(sandbox, "missing-source-checkout")
+        )
+        daemon = LiveProcessInstaller.new(
+          name: "daemon", binary_path: hive_bin,
+          args: %w[daemon start --foreground],
+          log_path: File.join(sandbox, "daemon-service.log")
+        )
+        web = LiveProcessInstaller.new(
+          name: "web", binary_path: hive_bin, args: %w[web],
+          log_path: File.join(sandbox, "web-service.log")
+        )
+
+        with_env("PATH" => [ File.dirname(hive_bin), FAKE_AGENT_BIN, ENV.fetch("PATH", "") ].join(File::PATH_SEPARATOR)) do
+          report = live_diagnostics_report
+          probe = Object.new
+          probe.define_singleton_method(:call) { report }
+          output = StringIO.new
+
+          begin
+            assert Hive::Commands::Setup.new(
+              project_path: project_root,
+              service: true,
+              json: true,
+              binary_path: hive_bin,
+              diagnostics: probe,
+              app_bundle: app_bundle,
+              daemon_installer: daemon,
+              web_installer: web,
+              output: output,
+              err: StringIO.new
+            ).call
+
+            payload = JSON.parse(output.string)
+            assert payload["ok"], payload.inspect
+            assert_equal hive_bin, payload["binary_path"]
+            assert File.directory?(File.join(project_root, ".hive-state")),
+                   "setup must initialize a genuinely fresh repository"
+            assert_equal project_root, Hive::Config.find_project(File.basename(project_root)).fetch("path")
+            assert daemon.status_snapshot["service_active"], "daemon foreground service must be alive"
+            assert web.status_snapshot["service_active"], "Rails foreground service must be alive"
+            wait_for_http!("http://127.0.0.1:4567/health?deep=1")
+
+            force_headless_agent!(project_root)
+            assert_bidirectional_parity!(project_root)
+          ensure
+            web.stop!
+            daemon.stop!
+          end
+        end
+      end
+    end
+  end
+
+  private
+
+  def live_diagnostics_report
+    results = healthy_results.map do |result|
+      next result unless result.name == "web_bundle"
+
+      Hive::Setup::Diagnostics::Result.new(
+        name: "web_bundle", status: "bootstrappable",
+        detail: "install local release bundle", fix: "hive setup",
+        bootstrappable: true
+      )
+    end
+    Hive::Setup::Diagnostics::Report.new(results: results, platform: "linux", ok: true)
+  end
+
+  def prepare_fast_daemon_config!
+    FileUtils.mkdir_p(Hive::Paths.config_home)
+    File.write(
+      Hive::Config.global_config_path,
+      {
+        "registered_projects" => [],
+        "daemon" => {
+          "poll_interval_sec" => 5,
+          "fast_poll_sec" => 1,
+          "edit_debounce_sec" => 1
+        }
+      }.to_yaml
+    )
+  end
+
+  def prepare_local_release_gem!
+    destination = Hive::Paths.data_home
+    FileUtils.mkdir_p(destination)
+    %w[bin lib templates schemas examples].each do |entry|
+      source = File.join(REPO_ROOT, entry)
+      FileUtils.cp_r(source, File.join(destination, entry)) if File.exist?(source)
+    end
+    %w[hive.gemspec install.md CHANGELOG.md LICENSE README.md].each do |entry|
+      FileUtils.cp(File.join(REPO_ROOT, entry), File.join(destination, entry))
+    end
+  end
+
+  def write_current_binary_wrapper!(sandbox)
+    path = File.join(sandbox, "bin", "hive")
+    root_bundle_path = ENV.fetch(
+      "LOCAL_WEB_E2E_ROOT_BUNDLE_PATH",
+      File.join(REPO_ROOT, "vendor", "root-bundle")
+    )
+    FileUtils.mkdir_p(File.dirname(path))
+    File.write(path, <<~SH)
+      #!/usr/bin/env bash
+      exec env \
+        BUNDLE_GEMFILE=#{Shellwords.escape(File.join(REPO_ROOT, 'Gemfile'))} \
+        BUNDLE_PATH=#{Shellwords.escape(root_bundle_path)} \
+        BUNDLE_DEPLOYMENT= BUNDLE_FROZEN= \
+        bundle exec ruby -I#{Shellwords.escape(File.join(REPO_ROOT, 'lib'))} \
+        #{Shellwords.escape(File.join(REPO_ROOT, 'bin', 'hive'))} "$@"
+    SH
+    FileUtils.chmod(0o755, path)
+    path
+  end
+
+  def force_headless_agent!(project_root)
+    path = File.join(project_root, ".hive-state", "config.yml")
+    config = YAML.safe_load_file(path)
+    config["claude"] = (config["claude"] || {}).merge("mode" => "headless")
+    config["execute"] = (config["execute"] || {}).merge("agent" => "claude")
+    File.write(path, config.to_yaml)
+  end
+
+  def assert_bidirectional_parity!(project_root)
+    project = File.basename(project_root)
+    tui_title = "Live TUI parity idea"
+    snapshot = Hive::Tui::StateSource.new.refresh_now
+    bubble = Hive::Tui::BubbleModel.new(
+      hive_model: Hive::Tui::Model.initial.with(
+        mode: :new_idea,
+        snapshot: snapshot,
+        scope: 0,
+        new_idea_project_name: project,
+        new_idea_buffer: tui_title,
+        new_idea_cursor: tui_title.length
+      )
+    )
+    capture_io { bubble.update(Hive::Tui::Messages::NEW_IDEA_SUBMITTED) }
+    assert_match(/\A\+ /, bubble.hive_model.flash.to_s)
+    tui_slug = wait_for_task_slug!(project_root, tui_title)
+    assert_includes wait_for_http!("http://127.0.0.1:4567/"), tui_title
+    wait_for_daemon_dispatch!(tui_slug)
+
+    web_title = "Live web parity idea"
+    create_web_idea!(project: project, title: web_title)
+    web_slug = wait_for_task_slug!(project_root, web_title)
+    web_snapshot = Hive::Tui::StateSource.new.refresh_now
+    assert web_snapshot.rows.any? { |row| row.slug == web_slug && row.display_name == web_title },
+           "web-created task must be visible through the TUI state source"
+    wait_for_daemon_dispatch!(web_slug)
+  end
+
+  def create_web_idea!(project:, title:)
+    uri = URI("http://127.0.0.1:4567/")
+    response = Net::HTTP.get_response(uri)
+    assert response.is_a?(Net::HTTPSuccess), response.inspect
+    token = response.body[/<meta name="csrf-token" content="([^"]+)"/, 1]
+    refute_nil token, "Rails root must expose a CSRF token"
+    cookie = Array(response.get_fields("set-cookie")).map { |value| value.split(";", 2).first }.join("; ")
+
+    request = Net::HTTP::Post.new("/ideas")
+    request["Cookie"] = cookie unless cookie.empty?
+    request.set_form_data(
+      "authenticity_token" => CGI.unescapeHTML(token),
+      "project" => project,
+      "text" => title
+    )
+    result = Net::HTTP.start(uri.host, uri.port) { |http| http.request(request) }
+    assert result.is_a?(Net::HTTPRedirection), result.inspect
+  end
+
+  def wait_for_http!(url, timeout: 45)
+    uri = URI(url)
+    wait_until!(timeout: timeout, failure: "#{url} did not become healthy") do
+      response = Net::HTTP.get_response(uri)
+      response.body if response.is_a?(Net::HTTPSuccess)
+    rescue IOError, SystemCallError, SocketError, Timeout::Error
+      nil
+    end
+  end
+
+  def wait_for_task_slug!(project_root, title, timeout: 20)
+    wait_until!(timeout: timeout, failure: "task #{title.inspect} never appeared") do
+      folder = Dir[File.join(project_root, ".hive-state", "stages", "*", "*")].find do |candidate|
+        idea = File.join(candidate, "idea.md")
+        File.file?(idea) && File.read(idea).include?(title)
+      end
+      File.basename(folder) if folder
+    end
+  end
+
+  def wait_for_daemon_dispatch!(slug, timeout: 30)
+    log_path = File.join(Hive::Paths.state_home, "logs", "daemon.log")
+    wait_until!(timeout: timeout, failure: "daemon never auto-dispatched #{slug}") do
+      next unless File.file?(log_path)
+
+      File.foreach(log_path).any? do |line|
+        line.include?(slug) && line.include?('"event":"dispatched"')
+      end
+    end
+  end
+
+  def wait_until!(timeout:, failure:)
+    deadline = Process.clock_gettime(Process::CLOCK_MONOTONIC) + timeout
+    loop do
+      result = yield
+      return result if result
+      raise failure if Process.clock_gettime(Process::CLOCK_MONOTONIC) >= deadline
+
+      sleep 0.1
+    end
+  end
+end
diff --git a/test/unit/bounded_subprocess_test.rb b/test/unit/bounded_subprocess_test.rb
new file mode 100644
index 00000000..307e8129
--- /dev/null
+++ b/test/unit/bounded_subprocess_test.rb
@@ -0,0 +1,47 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "hive/bounded_subprocess"
+require "rbconfig"
+
+class BoundedSubprocessTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_capture3_returns_output_and_status
+    out, err, status = Hive::BoundedSubprocess.capture3(
+      RbConfig.ruby, "-e", '$stdout.write("out"); $stderr.write("err")', timeout: 2
+    )
+
+    assert_equal "out", out
+    assert_equal "err", err
+    assert status.success?
+  end
+
+  def test_timeout_terminates_and_reaps_the_process_group
+    with_tmp_dir do |dir|
+      child_pid_path = File.join(dir, "child.pid")
+      script = <<~RUBY
+        child = spawn(#{RbConfig.ruby.inspect}, "-e", "sleep 30")
+        File.write(#{child_pid_path.inspect}, child)
+        sleep 30
+      RUBY
+
+      error = assert_raises(Hive::BoundedSubprocess::TimeoutError) do
+        Hive::BoundedSubprocess.capture3(RbConfig.ruby, "-e", script, timeout: 1.0)
+      end
+
+      assert_operator error.elapsed, :>=, 1.0
+      child_pid = Integer(File.read(child_pid_path))
+      refute process_alive?(child_pid), "timeout must kill descendants in the spawned process group"
+    end
+  end
+
+  private
+
+  def process_alive?(pid)
+    Process.kill(0, pid)
+    true
+  rescue Errno::ESRCH
+    false
+  end
+end
diff --git a/test/unit/commands/daemon_test.rb b/test/unit/commands/daemon_test.rb
index f87b788e..17984300 100644
--- a/test/unit/commands/daemon_test.rb
+++ b/test/unit/commands/daemon_test.rb
@@ -164,6 +164,36 @@ class HiveCommandsDaemonTest < Minitest::Test
                  "answer_digest.hour must be forwarded into the scheduler"
   end
 
+  def test_start_daemon_wires_current_service_installer_binary_for_repairs
+    require "hive/commands/daemon/service_installer"
+
+    command = daemon("start", dry_run: true)
+    dispatcher = FakeDispatcher.new([])
+    resolved = nil
+    installer = Object.new
+    installer.define_singleton_method(:resolved_binary_for_status) { "/current/bin/hive" }
+
+    with_replaced_singleton_method(Hive::Lock, :process_start_time, ->(pid) { "start-#{pid}" }) do
+      with_global_start_config(daemon_config) do
+        with_replaced_singleton_method(
+          Hive::Commands::Daemon::ServiceInstaller,
+          :new,
+          ->(**_kwargs) { installer }
+        ) do
+          with_replaced_singleton_method(Hive::Daemon::Dispatcher, :new, lambda { |**kwargs|
+            supervisor = kwargs.fetch(:supervisor)
+            resolved = supervisor.send(:resolved_maintenance_binary)
+            dispatcher
+          }) do
+            command.call
+          end
+        end
+      end
+    end
+
+    assert_equal "/current/bin/hive", resolved
+  end
+
   def test_start_daemon_invokes_reexec_when_dispatcher_signals_drift
     command = daemon("start", dry_run: true)
     dispatcher = FakeDispatcher.new([], true) # signals drift
@@ -345,6 +375,9 @@ class HiveCommandsDaemonTest < Minitest::Test
     }
     fake = Struct.new(:state) do
       def service_state = state
+      def resolved_binary_for_status = "/opt/hive/bin/hive"
+      def installed_binary_path = "/opt/hive/bin/hive"
+      def binary_parse_error = nil
     end.new(state)
     require "hive/commands/daemon/service_installer"
     out, _err = with_replaced_singleton_method(
@@ -359,6 +392,9 @@ class HiveCommandsDaemonTest < Minitest::Test
     # Existing fields must survive the merge.
     assert_equal true, doc.fetch("running")
     assert_equal 1234, doc.fetch("pid")
+    assert_equal "unreadable", doc.fetch("binary_drift"),
+                 "a configured binary that cannot be executed must remain actionable"
+    assert_equal "/opt/hive/bin/hive", doc.fetch("expected_binary")
 
     require "json_schemer"
     schema = JSONSchemer.schema(JSON.parse(File.read(Hive::Schemas.schema_path("hive-daemon-status"))))
@@ -383,6 +419,7 @@ class HiveCommandsDaemonTest < Minitest::Test
     assert_nil doc.fetch("service_enabled")
     assert_nil doc.fetch("unit_path")
     assert_equal true, doc.fetch("running")
+    assert_equal "unreadable", doc.fetch("binary_drift")
 
     require "json_schemer"
     schema = JSONSchemer.schema(JSON.parse(File.read(Hive::Schemas.schema_path("hive-daemon-status"))))
diff --git a/test/unit/commands/setup/exit_code_test.rb b/test/unit/commands/setup/exit_code_test.rb
new file mode 100644
index 00000000..c07593ff
--- /dev/null
+++ b/test/unit/commands/setup/exit_code_test.rb
@@ -0,0 +1,71 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "hive/commands/setup"
+require "hive/setup/diagnostics"
+require "stringio"
+
+class SetupExitCodeTest < Minitest::Test
+  include HiveTestHelper
+
+  def diag(ok:)
+    results = [
+      Hive::Setup::Diagnostics::Result.new(
+        name: "ruby", status: "ok", detail: "ok", fix: nil, bootstrappable: false
+      )
+    ]
+    unless ok
+      results << Hive::Setup::Diagnostics::Result.new(
+        name: "gh", status: "unauthenticated", detail: "need login",
+        fix: "gh auth login", bootstrappable: false
+      )
+    end
+    # Pad to avoid empty hard-failure edge cases on other names
+    %w[git tmux claude codex node npm qmd web_bundle sqlite].each do |n|
+      results << Hive::Setup::Diagnostics::Result.new(
+        name: n, status: "ok", detail: "ok", fix: nil, bootstrappable: false
+      )
+    end
+    Hive::Setup::Diagnostics::Report.new(
+      results: results,
+      platform: "linux",
+      ok: ok
+    )
+  end
+
+  def test_success_does_not_raise
+    out = StringIO.new
+    report = diag(ok: true)
+    probe = Object.new
+    probe.define_singleton_method(:call) { report }
+    cmd = Hive::Commands::Setup.new(
+      project_path: Dir.mktmpdir,
+      no_bootstrap: true,
+      json: true,
+      diagnostics: probe,
+      output: out,
+      err: StringIO.new
+    )
+    assert cmd.call
+    assert JSON.parse(out.string)["ok"]
+  end
+
+  def test_hard_diagnostic_failure_raises_after_json_emit
+    out = StringIO.new
+    report = diag(ok: false)
+    probe = Object.new
+    probe.define_singleton_method(:call) { report }
+    cmd = Hive::Commands::Setup.new(
+      project_path: Dir.mktmpdir,
+      no_bootstrap: true,
+      json: true,
+      diagnostics: probe,
+      output: out,
+      err: StringIO.new
+    )
+    assert_raises(Hive::Error) { cmd.call }
+    payload = JSON.parse(out.string)
+    refute payload["ok"]
+    assert payload["diagnostics"]["results"].any? { |r| r["fix"] == "gh auth login" }
+  end
+end
